import type { DId } from '../../utils/types';
import React from 'react';
export interface DTableFilterRef {
    updatePosition: () => void;
}
export interface DTableFilterItem<V extends DId> {
    label: string;
    value: V;
    disabled?: boolean;
}
export interface DTableFilterProps<V extends DId, T extends DTableFilterItem<V>> extends React.ButtonHTMLAttributes<HTMLButtonElement> {
    dList: T[];
    dSelected?: V | null | V[];
    dVisible?: boolean;
    dLoading?: boolean;
    dSearchable?: boolean;
    dSearchValue?: string;
    dMultiple?: boolean;
    dCustomItem?: (item: T) => React.ReactNode;
    dCustomSearch?: {
        filter?: (value: string, item: T) => boolean;
        sort?: (a: T, b: T) => number;
    };
    dPopupClassName?: string;
    onSelectedChange?: (value: any, item: any) => void;
    onVisibleChange?: (visible: boolean) => void;
    onSearchValueChange?: (value: string) => void;
    onScrollBottom?: () => void;
    afterVisibleChange?: (visible: boolean) => void;
}
declare function TableFilter<V extends DId, T extends DTableFilterItem<V>>(props: DTableFilterProps<V, T>, ref: React.ForwardedRef<DTableFilterRef>): JSX.Element | null;
export declare const DTableFilter: <V extends DId, T extends DTableFilterItem<V>>(props: DTableFilterProps<V, T> & React.RefAttributes<DTableFilterRef>) => ReturnType<typeof TableFilter>;
export {};
